﻿
using Syncfusion.UI.Xaml.Controls.Navigation;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace _128055_SfTabControlBinding
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private ObservableCollection<Employee> employees;

        private List<object> tabStripMenuItem;

        public ObservableCollection<Employee> Employees

        {

            get { return employees; }

            set { employees = value; }

        }

        public List<object> TabStripMenuItem

        {

            get { return tabStripMenuItem; }

            set { tabStripMenuItem = value; }

        }



        private void SfTabControl_Loaded(object sender, RoutedEventArgs e)
        {
            // Collection which returns tab item
            Employees = new ObservableCollection<Employee>();
            Employees.Add(new Employee() { Name = "Paul Vent", Description = "Description about Paul Vent" });
            Employees.Add(new Employee() { Name = "Niko", Description = "Description about Niko" });

            // Collection which returns tab strip menu items
            TabStripMenuItem = new List<object>();
            TabStripMenuItem.Add(new Employee() { Name = "James", Description = "Description about James" });
            TabStripMenuItem.Add(new Employee() { Name = "Carl", Description = "Description about Carl" });

            this.DataContext = this;
            tabControl.TabstripMenuItems = TabStripMenuItem;


            Type mdiManagerType = tabControl.GetType();
            PropertyInfo mdiClient = mdiManagerType.GetProperty("TabStripMenuButton", BindingFlags.Instance | BindingFlags.NonPublic);
            var source = mdiClient.GetValue(tabControl, null);
            RepeatButton tabStripButton = (RepeatButton)source;

            if (tabStripButton != null)
            {
                tabStripButton.Click += TabStripButton_Click;
            
            }

        }

        private void TabStripButton_Click(object sender, RoutedEventArgs e)
        {
            Type mdiManagerType = tabControl.GetType();
            PropertyInfo mdiClient = mdiManagerType.GetProperty("TabStripMenuList", BindingFlags.Instance | BindingFlags.NonPublic);
            var source = mdiClient.GetValue(tabControl, null);
            ListView list = (ListView)source;
            list.SelectedItem = null;

            if (list != null)
            {
                list.SelectionChanged += List_SelectionChanged;
            }
        }

        private void List_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

            ListView selectedIteminView = sender as ListView;


            if (selectedIteminView.SelectedItem is Employee)
            {
                Employee employee = new Employee() { Name = (selectedIteminView.SelectedItem as Employee).Name, Description = (selectedIteminView.SelectedItem as Employee).Description };
                bool isNotAddedAlready = false;

                for(int i = 0; i < Employees.Count; i ++)
                {
                    Employee emp = Employees[i] as Employee;

                    if(emp.Name != employee.Name)
                    {
                        isNotAddedAlready = true;
                    }
                    else
                    {
                        isNotAddedAlready = false;
                        return;
                    }
                }

                if (isNotAddedAlready)
                {
                    this.Employees.Add(employee);
                }
            }

           
            tabControl.SelectedIndex = tabControl.Items.Count - 1;
        }
    }
}
